
// Default values
let ss3 = "SS3";
let js3 = "JS3";


function getPhoneNumbers (event, level) {
   // window.event.preventDefault();
    $(".progress").removeClass("hide").show();
    $.ajax({
        data: {level: level},
        type: 'GET',
        url: `${site.process}custom?case=edcPhoneNumbers`,
        success: function (data){
            $(".progress").addClass("hide");
            var data_array = isJson(data);
            if(data_array){
                window.open(`${site.process}download?filename=${data_array.url}`, '_blank');
            }else{
                Materialize.toast("Error downloading file", 2000, "red");
            }
        }
    })
     return false;
}

function getlinksch_class (this_element) {
    let _db = $(this_element).val();
    let target = $(this_element).attr("data-target");
    let pageid = $(this_element).data("pageid");
    id_class = '#' + target + pageid;
    // let army = target + pageid;
    // console.log(army);
    $('#'+ target + pageid).empty();
    $(".progress").removeClass("hide").show();
    //get  url_data using php to avoid CORS error
     $.ajax({
        data: {_db: _db, action: "levels"},
        type: 'GET',
        url: `${site.process}custom?case=getLevels`,
        success: function(data){
            var link_cls_arr = isJson(data);
            $(".progress").addClass("hide");
            for (var index in link_cls_arr) {
                $(id_class).append($("<option>").attr({value:index}).text(link_cls_arr[index]))
            }
            let schclass = $(id_class).val();
            if (schclass === null){
                Materialize.toast("No class found for this School", 2000, "red");
            }
        }

    })

}

function downloadfile(data) {
  if(data.url){
    window.open(`${site.process}download?filename=${data.url}`, '_blank');
  }else {
    alert("No a valid file path")
  }
}
