<?php
$thisyear = date("Y");
$last3years = $thisyear - 3;
$roles = [
  "Home" => [
    "icon"  => "home",
    "links" => [
      [
        "title" => "Dashboard",
        "url"   => "custom-view/dashboard"
      ],
    ]
  ],
  "Organization Setup" => [
    "icon"  => "settings",
    "links" => [
      [
        "title" => "Settings",
        "url"   => "form-view/organization"
      ],
      [
        "title" => "Role",
        "url"   => "content-view/role"
      ],
      [
        "title" => "Labels",
        "url"   => "content-view/label"
      ]
    ]
  ],
  "People" => [
    "icon"  => "people",
    "links" => [
      [
        "title" => "Admin Users",
        "url"  => "content-view/users"
      ],
      [
        "title" => "Staff Records",
        "url"  => "content-view/staff"
      ],
      [
        "title" => "Subscribers",
        "url"  => "content-view/subscribers"
      ],
    ]
  ],
  "Modules" => [
    "icon"  => "bubble_chart",
    "links" => [
      [
        "title" => "Our Portfolio",
        "url"  => "content-view/websites"
      ],
      [
        "title" => "Post to Mylelo",
        "url"  => "custom-view/mylelopostjob"
      ],
      [
        "title" => "Linkschool Phone Numbers",
        "url"  => "form-view/linkschool"
      ],
      [
        "title" => date("Y").' EDC JS3 Numbers',
        "url"  => "javascript/getPhoneNumbers(this, js3)"
      ],
      [
        "title" => date("Y").' EDC SS3 Numbers',
        "url"  => "javascript/getPhoneNumbers(this, ss3)"
      ],
    ]
  ],
  "Navigation" => [
    "icon"  => "publish",
    "links" => [
      [
        "title" => "Pages",
        "url"  => "content-view/page"
      ],
      [
        "title" => "Business",
        "url"  => "content-view/business"
      ],
      [
        "title" => "Industries",
        "url"  => "content-view/industry"
      ],
      [
        "title" => "Insights",
        "url"  => "content-view/category"
      ],
      [
        "title" => "Products",
        "url"  => "content-view/product"
      ],
      [
        "title" => "Sub Pages",
        "url"  => "content-view/subPage"
      ]
    ]
  ],

  "Blog" => [
    "icon"  => "local_library_white",
    "links" => [
      [
        "title" => "Articles",
        "url"  => "content-view/article"
      ],
      [
        "title" => "News",
        "url"  => "content-view/news"
      ],
      [
        "title" => "Case Study",
        "url"  => "content-view/caseStudy"
      ],
    ]
  ],
  
  "Events" => [
    "icon"  => "event_note",
    "links" => [
      [
        "title" => "Internal Events",
        "url"  => "content-view/internal_events"
      ],
      [
        "title" => "External Events",
        "url"  => "content-view/external_events"
      ],
    ]
  ],
  
  "Opportunities" => [
    "icon"  => "diversity",
    "links" => [
      [
        "title" => "Opportunities",
        "url"  => "content-view/opportunity"
      ],
      [
        "title" => "Contests",
        "url"  => "content-view/contest"
      ],
      [
        "title" => "Seminars",
        "url"  => "content-view/seminar"
      ],
    ]
  ],
  "Boot camps" => [
    "icon"  => "code_alt",
    "links" => [
      [
        "title" => "Tech Boot Camps",
        "url"  => "content-view/bootcamp"
      ],
      [
        "title" => "Coding Boot Camp",
        "url"  => "content-view/coding_bootcamp"
      ],
    ]
  ],
  
  "Academy" => [
    "icon"  => "university",
    "links" => [
      [
        "title" => "Administrators",
        "url"  => "content-view/academy_admin"
      ],
      [
        "title" => "Students",
        "url"  => "content-view/academy_student"
      ],
      [
        "title" => "Courses",
        "url"  => "content-view/academy_course"
      ],
      [
        "title" => "Course Categories",
        "url"  => "content-view/course_cat"
      ],
      [
        "title" => "Learning centers",
        "url"  => "content-view/learning_center"
      ],
      [
        "title" => "Course Payments",
        "url"  => "content-view/course_payments"
      ],
      [
        "title" => "Coding Boot Camp payments",
        "url"  => "content-view/boot_camp_payments"
      ],
      [
        "title" => "Create Certificate",
        "url"  => "content-view/upload_cert"
      ],
      [
        "title" => "Jobs Categories",
        "url"  => "content-view/job_cat"
      ],
      [
        "title" => "Organizations",
        "url"  => "content-view/employers"
      ],
      [
        "title" => "Tech Jobs",
        "url"  => "content-view/tech_job"
      ],
    ]
  ],
];
?>
