<?php
$card_colors = ['Teal','DodgerBlue','SlateGray','DarkViolet','Indigo','DarkCyan','SteelBlue'];
$a_url = "{$uri->site}{$item->type}/{$item->id}-{$item->url}";

list($width, $height)  = getimagesize(absolute_filepath($item->image->src));
?>
<div class="card_curvy" <?php if(isset($item->image) == false && isset($card_color)){echo 'style="background: linear-gradient(27deg,'.$card_color.' 0%, #efdacfe6 100%)"';}else{echo 'style="background-image:url('.$item->image->src.')"';} ?> data-id="<?=$item->id ?>" data-type="<?=$item->type ?>">
	<div class="card-overlay"></div>
	<div class="card-info" style="<?php if(isset($card_color))echo 'background-color:'.$card_color.' !important'; ?>">
		<div class="col-sm-12 noPad float-left">
			<?php if(isset($item->category)){?><a href="<?=$item->category_link ?>" class="card-category"><?=$item->category?></a><?php }?>
		</div>
		<div class="col-sm-12 noPad float-left">
			<a href="<?=$a_url ?>" class="card-title" ><?= $item->title?></a>
			<hr class="white_line" style="margin-top: 0;">
		</div>
		<div class="col-sm-12 noPad float-left">
			<span class="card-body"><?php if(strlen($item->title) > 50) echo substr(strip_tags($item->body), 0, 35); else echo substr(strip_tags($item->body), 0, 70); echo '...'?></span>

		</div>
	</div>
	<div class="card_design" style="<?php if(isset($card_color))echo 'background-color:'.$card_color; ?>"></div>
	<div class="social_share">
		<?php require('components/social_share.php') ?>
	</div>
</div>
