<?php
session_start();
require_once('admin/controllers/Controllers.php');
require_once('admin/backendProject/functions/cache.php');
$generic = new Generic;
$paramControl = new ParamControl($generic);
$db = $generic->connect();
$uri = $generic->getURIdata();
$css = $generic->domain.'asset/css/';
$js = $generic->domain.'asset/js/';
$_color=array("white","green","yellow darken-4","red","blue darken-3","cyan darken-3","teal darken-4");
if($uri->page_source == 'rear' || $uri->page_source == 'administrator'){
	header("Location: {$uri->site}admin");
	die();
}else if($uri->page_source == "mod-url"){
	$all = $generic->getFromTable("content", "url=NULL, url=''", 1, 0);
	foreach ($all as $key => $row) {
		$row = urlSlug($row);
		$db->query("UPDATE content set url='{$row->url}' WHERE id='{$row->id}'");
	}
	die("Executed");
}
$company = company();
$pages_list = get_pages();
$nav = get_nav();

$page_exists = is_numeric(array_search($uri->page_source, $pages_list));

$homepages 	= ["", "home", "index"];
$portal 	= ["portal", "student-login", "admin-login", "portal-admin", "logout"];

$cache_control = "?v=f6";
if($page_exists == true){
	if(in_array($uri->page_source, $homepages)){
		require_once("views/home.php");
	} elseif($uri->page_source == "test"){
		require_once("processor/sheets/quickstart/quickstart.php");
	}else{
		$param = $paramControl->get_params($uri->page_source);
		if(isset($param->view)){
			require_once("views/{$param->view}.php");
		}else{
			$_404 = true;
		  require_once("views/home.php");
		}
	}
}elseif (in_array($uri->page_source, $portal)) {
	$page_source = $uri->page_source;
	
	if (preg_match('/(?:student|admin)-login$/', $page_source, $match) === 1) {
		$user_type = strstr($page_source, 'student') !== FALSE ? 'student' : 'admin';
		$page_source = 'portal_login';
	}
	$page_source = str_replace('-', '_', $page_source);
	require_once "./portal/views/{$page_source}.php";
} elseif (in_array($uri->page_source, ['admin_pages', 'portal_pages'])) {
	require_once "./portal/views/load_{$uri->page_source}.php";
} elseif ($uri->page_source == 'test_page') {
	require_once "test_file_dialog.php";
} else{
	$_404 = true;
	require_once("views/home.php");
}

?>
