<nav class="col-md-2 sidebar">
  <div class="sidebar-sticky">
    <h6 class="sidebar-heading d-flex justify-content-between align-items-center px-4 mt-5 mb-1 text-light">
      <span>Course Section</span>
      <a class="d-flex align-items-center text-light" href="javascript:void(0);">
        <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-plus-circle">
          <circle cx="12" cy="12" r="10"></circle>
          <line x1="12" y1="8" x2="12" y2="16"></line>
          <line x1="8" y1="12" x2="16" y2="12"></line>
        </svg>
      </a>
    </h6>
    <ul class="nav flex-column mt-4">
      <li class="nav-item">
        <a class="nav-link text-center active" href="#main" data-page="dashboard">
          <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-home">
            <path d="M3 9l9-7 9 7v11a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2z"></path>
            <polyline points="9 22 9 12 15 12 15 22"></polyline>
          </svg>
          Dashboard <span class="sr-only">(current)</span>
        </a>
      </li>
      <?php if ($_SESSION['type'] == 'Tutor') { ?><li class="nav-item">
        <a class="nav-link text-center" href="#main" data-page="assigned_courses">
          <svg width="24" height="24" class="feather">
            <use xlink:href="#video-stack" />
          </svg>
          Courses
        </a>
      </li><?php } ?>
      <li class="nav-item">
        <a class="nav-link text-center" href="#main" data-page="survey">
          <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-bar-chart-2">
            <line x1="18" y1="20" x2="18" y2="10"></line>
            <line x1="12" y1="20" x2="12" y2="4"></line>
            <line x1="6" y1="20" x2="6" y2="14"></line>
          </svg>
          Surveys & Responses
        </a>
      </li>
    </ul>
    <h6 class="sidebar-heading d-flex justify-content-between align-items-center px-4 mt-4 mb-1 text-light">
      <span>Student Section</span>
      <a class="d-flex align-items-center text-light" href="javascript:void(0);">
        <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-plus-circle">
          <circle cx="12" cy="12" r="10"></circle>
          <line x1="12" y1="8" x2="12" y2="16"></line>
          <line x1="8" y1="12" x2="16" y2="12"></line>
        </svg>
      </a>
    </h6>
    <ul class="nav flex-column mb-2">
      <li class="nav-item">
        <a class="nav-link text-center" href="#main" data-page="students">
          <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" class="feather">
            <use xlink:href="#students-icon" />
          </svg>
          Students
        </a>
      </li><?php if ($_SESSION['type'] == 'Front Desk Officer') { ?>
        <li class="nav-item">
          <a class="nav-link text-center" href="#main" data-page="payment">
            <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather-text">
              <path d="M14 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V8z"></path>
              <polyline points="14 2 14 8 20 8"></polyline>
              <line x1="16" y1="13" x2="8" y2="13"></line>
              <line x1="16" y1="17" x2="8" y2="17"></line>
              <polyline points="10 9 9 9 8 9"></polyline>
            </svg>
            Payments
          </a>
        </li><?php } ?>
    </ul>
    <ul class="nav flex-column mt-5">
      <li class="nav-item">
        <a class="nav-link text-center" href="<?= $uri->site ?>logout" id="signout">
          <svg width="24" height="24" class="feather-text">
            <use xlink:href="#signout-icon" />
          </svg>
          Sign Out
        </a>
      </li>
    </ul>
  </div>
</nav>