<?php 
$site_dir ='';
$data = json_decode($data);
$slider = $data->slider;
$lists = $data->lists;
$count = 0;
$category = ($page_source == 'category')?'Insights - ':ucwords($page_source).' - ';

foreach($lists as $k => $nonsense){
	$count++;
}

// print_r($lists[0]->title);
//$products = $data->products;
$data->title = strip_tags($category).strip_tags($lists[0]->title).' | Digital Dreams LTD';
?>


<!doctype html>
<html lang="">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">
<title><?=$data->title?></title>

<?php // die($site_dir); ?>
<?php require_once($site_dir.'components/csslinks.php')?>
<?php require_once($site_dir.'components/seo_tags.php')?>
</head>
<body data-site="<?=$site?>">
<?php require_once($site_dir.'components/nav.php')?>

<div class='float-left posRel fullWidth'>
    <div id="carouselExampleIndicators" class="carousel slide not-full" data-ride="carousel">
        <ol class="carousel-indicators">
            <?php foreach($slider as $k => $image){?>
            <li data-target="#carouselExampleIndicators" data-slide-to="<?=$k?>" class="<?php if($k==0)echo 'active'; ?>"></li>
            <?php } ?>
        </ol>
        <div class="carousel-inner" role="listbox">
            <?php foreach($slider as $k => $image){
			list($width, $height)  = getimagesize(str_replace('../','',$site.$image->src));
			?>
			<div class="carousel-item <?php if($k==0)echo ' active'; ?>">
                <div class="float-right posAbs" style="padding: 50px; right: 0; margin: 120px 150px 0 0px;width: 600px;z-index: 1;">
                    <h1 class="site_title text_bold_7 text-white text-right animated bounceInUp" style="animation-delay: 0.01s;animation-duration: 1.5s;"><?=$image->title?></h1>
                    <h5 class="text-white text-right animated bounceInUp" style="font-weight:200; animation-delay: 0.11s;animation-duration: 1.5s;"><?=$image->desc?></h5>
                    <?php if(!empty($image->anchor->href)){ ?>
                    	<a href="<?=$image->anchor->href?>" class="btn btn-lg btn-info float-right animated bounceInUp" style="animation-delay: 0.21s;animation-duration: 1.5s;"><?=$image->anchor->name?></a>
					<?php }?>
                </div>
                <div class="custom-overlay posAbs float-left fullWidth fullHeight"></div>
                <img class="d-block <?php if($width>$height || $width==$height){echo 'slide-fh';}else echo 'slide-fw' ?>" src="<?=str_replace('../','',$site.$image->src) ?>" alt="First slide">
            </div>
			<?php } ?>
        </div>
        <?php if(count($slider) > 1){?>
		<a class="carousel-control-prev" href="#carouselExampleIndicators" role="button" data-slide="prev">
            <i class="now-ui-icons arrows-1_minimal-left"></i>
        </a>
        <a class="carousel-control-next" href="#carouselExampleIndicators" role="button" data-slide="next">
            <i class="now-ui-icons arrows-1_minimal-right"></i>
        </a>
		<?php } ?>
    </div>
</div>


<div class="col-md-12 posRel float-left list-view">
        <div class="posRel col-sm-12 float-left">
            <h3 class="headd text_bold_7 text-left text-capitalize mt-4 pl-3 pr-3"><?=str_replace('-',' ',$event)?></h3>
        </div>
         <hr class="style-two" style="margin-top: 0;">
        <div class="col-lg-12 noPad">
        	<div class="col-lg-9  posRel float-left">
        		<?php for($k = 0; $k < 6; $k++ ){ 
					if(isset($lists[$k])){ $item = $lists[$k];?>
						<div class="col-md-12 col-sm-12 posRel float-left animated ">
							<?php require('components/card_list.php');?>
						</div>
					 <?php }
				}?>
        	</div>
        	<div class="col-lg-3 posRel float-left side-pad">
        		<?php if(isset($lists[6])){
					for($k = 6; $k < 5; $k++ ){
						if(isset($lists[$k])){$item = $lists[$k];?>
							<div class="col-md-12 col-sm-12 posRel float-left animated ">
								<?php require('components/card_curvy.php');?>
							</div>
							<hr class="style-two" style="margin-top: 0;">
						<?php }
					}
				}?>
        	</div>
        </div>
        <?php /*if(isset($lists[11])){?>
			<div class="col-lg-12 bg-wall float-left posRel">
        		<div class="container">
					<?php for($ik = 11; $ik < 5; $ik++ ){
						if(isset($lists[$ik])){$item = $lists[$ik];?>
							<div class="col-md-4 col-sm-12 posRel float-left animated ">
								<?php require('components/card_arrow.php');?>
							</div>
						<?php }
					}?>
				</div>
			</div>
        <?php }*/?> 
        <div class="col-sm-12  noPad second-screen  posRel float-left"  style="margin-top: 40px">
        	<div class="col-lg-3 posRel float-left side-pad">
        		<?php if(isset($lists[11])){
					for($k = 11; $k < 5; $k++ ){
						if(isset($lists[$k])){$item = $lists[$k];?>
							<div class="col-md-12 col-sm-12 posRel float-left animated ">
								<?php require('components/card_curvy.php');?>
							</div>
							<hr class="style-two" style="margin-top: 0;">
						<?php }
					}
				}?>
        	</div>
       
        	<div class="col-lg-9  posRel float-left">
			<?php for($k = 16; $k < 6; $k++ ){ 
				if(isset($lists[$k])){ $item = $lists[$k];?>
					<div class="col-md-12 col-sm-12 posRel float-left animated ">
						<?php require('components/card_list.php');?>
					</div>
				 <?php }
			}?>
			</div>
       </div>	

</div>

<?php require_once($site_dir.'components/footer.php')?>
	</body>
</html>