<?php
$clientid=1;

$query19 = "CREATE TABLE IF NOT EXISTS customer (
  cId int(10) unsigned NOT NULL AUTO_INCREMENT,
  transcid varchar(50) DEFAULT NULL,
  customername varchar(255) DEFAULT NULL,
  customer varchar(255) DEFAULT NULL,
  contact varchar(255) DEFAULT NULL,
  address varchar(255) DEFAULT NULL,
  address2 varchar(255) DEFAULT NULL,
  gender varchar(6) DEFAULT NULL,
  city varchar(255) DEFAULT NULL,
  state varchar(255) DEFAULT NULL,
  zipcode varchar(255) DEFAULT NULL,
  country varchar(255) DEFAULT NULL,
  telephone varchar(50) DEFAULT NULL,
  telephone1 varchar(50) DEFAULT NULL,
  email varchar(255) DEFAULT NULL,
  website varchar(255) DEFAULT NULL,
  fax varchar(255) DEFAULT NULL,
  sales_tax_code varchar(255) DEFAULT NULL,
  latlng varchar(255) DEFAULT NULL,
  wid int(11) DEFAULT NULL,
  warehouse varchar(255) DEFAULT NULL,
  shipping_details text DEFAULT NULL,
  others text DEFAULT NULL,
  publish int(11) DEFAULT NULL,
  type varchar(100) DEFAULT NULL,
  inactive varchar(10) DEFAULT NULL,
  prospect varchar(10) DEFAULT NULL,
  picture varchar(255) DEFAULT NULL,
  referal varchar(255) DEFAULT NULL,
  sales_representative_id varchar(255) DEFAULT NULL,
  gl_sales_account varchar(255) DEFAULT NULL,
  ship_via varchar(255) DEFAULT NULL,
  pricing_level int(11) DEFAULT NULL,
  use_standard_terms varchar(10) DEFAULT NULL,
  cod_terms varchar(10) DEFAULT NULL,
  prepaid_terms varchar(10) DEFAULT NULL,
  terms_type varchar(10) DEFAULT NULL,
  due_days int(11) DEFAULT NULL,
  discount_days int(11) DEFAULT NULL,
  discount_percent float(12,2) DEFAULT NULL,
  credit_limit float(12,2) DEFAULT NULL,
  charge_finance_charges varchar(10) DEFAULT NULL,
  due_month_end_terms varchar(10) DEFAULT NULL,
  cardholder_name varchar(255) DEFAULT NULL,
  credit_card_address1 varchar(255) DEFAULT NULL,
  credit_card_address2 varchar(255) DEFAULT NULL,
  credit_card_city varchar(255) DEFAULT NULL,
  credit_card_state varchar(255) DEFAULT NULL,
  credit_card_zip_code varchar(255) DEFAULT NULL,
  credit_card_country varchar(255) DEFAULT NULL,
  credit_card_number varchar(255) DEFAULT NULL,
  credit_card_expiration_date varchar(255) DEFAULT NULL,
  current_balance float(10,2) DEFAULT NULL,
  punit varchar(50) DEFAULT NULL,
  created_by int(11) DEFAULT NULL,
  clientid int(11) DEFAULT NULL,
  customer_password varchar(100) DEFAULT NULL,
  customer_since DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
  last_login datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (cId)
)";

$query20 = "CREATE TABLE IF NOT EXISTS item (
  tid int(10) unsigned NOT NULL AUTO_INCREMENT,
  transcid varchar(50)  DEFAULT NULL,
  itemID varchar(100)  DEFAULT NULL,
  description varchar(100)  DEFAULT NULL,
  sales_desc varchar(200)  DEFAULT NULL,
  purchase_desc varchar(200)  DEFAULT NULL,
  upc varchar(200)  DEFAULT NULL,
  categories int(200) DEFAULT NULL,
  pcategories varchar(100)  DEFAULT NULL,
  brand int(11) DEFAULT NULL,
  warehouse varchar(255)  DEFAULT NULL,
  sunit_value decimal(10,2) DEFAULT 1,
  unit varchar(200)  DEFAULT NULL,
  sunit varchar(200)  DEFAULT NULL,
  subdivision int(11) DEFAULT NULL,
  weight decimal(14,2) DEFAULT NULL,
  unit_cost decimal(14,2) DEFAULT NULL,
  taxable varchar(10)  DEFAULT NULL,
  price1 float(10,2) DEFAULT NULL,
  price2 float(10,2) DEFAULT NULL,
  price3 float(10,2) DEFAULT NULL,
  price4 float(10,2) DEFAULT NULL,
  price5 float(10,2) DEFAULT NULL,
  price6 float(10,2) DEFAULT NULL,
  price7 float(10,2) DEFAULT NULL,
  price8 float(10,2) DEFAULT NULL,
  price9 float(10,2) DEFAULT NULL,
  price10 float(10,2) DEFAULT NULL,
  picture text ,
  threshold varchar(255)  DEFAULT NULL,
  publish int(11) DEFAULT 0,
  inactive tinyint(10) DEFAULT '1' COMMENT '0-inactive;1-active',
  commission varchar(10)  DEFAULT NULL,
  costing_method varchar(10)  DEFAULT NULL,
  gl_sales_account varchar(50)  DEFAULT NULL,
  gl_inventory_account varchar(50)  DEFAULT NULL,
  gl_cos_account varchar(50)  DEFAULT NULL,
  minimum_stock int(11)  DEFAULT 0,
  reorder_quantity varchar(50)  DEFAULT NULL,
  vendor_id varchar(50)  DEFAULT 0,
  buyer_id varchar(50)  DEFAULT 0,
  alternate_vendor varchar(50)  DEFAULT NULL,
  substitution varchar(50)  DEFAULT NULL,
  special_note varchar(255)  DEFAULT NULL,
  special_order varchar(50)  DEFAULT NULL,
  is_master_stock int(11)  DEFAULT 0,
  master_stock_data text  DEFAULT NULL,
  master_stock_id int(11)  DEFAULT 0,
  slave_stock_id varchar(50)  DEFAULT 0,
  primary_attrib_name varchar(50)  DEFAULT NULL,
  substock_primary_attrib_desc varchar(50)  DEFAULT NULL,
  secondary_attrib_name varchar(50)  DEFAULT NULL,
  substock_second_attrib_desc varchar(50)  DEFAULT NULL,
  quantity_on_sales_orders varchar(50)  DEFAULT NULL,
  quantity_on_purchase_orders varchar(50)  DEFAULT NULL,
  quantity_on_hand int(11)  DEFAULT 0,
  asset_type int(11) DEFAULT NULL,
  date_purchased date DEFAULT NULL,
  created_by int(11) DEFAULT 0,
  updated_by int(11) DEFAULT 0,
  clientid int(11) DEFAULT 0,
  sold int(11) DEFAULT 0,
  date_created DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
  date_updated DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (tid)
)";

$query21 = "CREATE TABLE IF NOT EXISTS default_account_settings (
  sid int unsigned not null auto_increment,
  primary key (sid),
  account_receivable varchar(255),
  other_receivable varchar(255),
  account_payable varchar(255),
  other_payable varchar(255),
  cash varchar(255),
  sales varchar(255),
  cost_of_sales varchar(255),
  fixed_assets varchar(255),
  other_assets varchar(255),
  expenses varchar(255),
  current_assets varchar(255),
  current_liabilities varchar(255),
  long_term_liabilities varchar(255),
  equity_open varchar(255),
  equity_closed varchar(255),
  equity_retained varchar(255),
  inventory varchar(255),
  accumulated_depreciation varchar(255),
  payroll varchar(255),
  discount varchar(255),
  pur_discount varchar(255),
  production varchar(255),
  clientid int
)";

$quer22 = "CREATE TABLE IF NOT EXISTS category_type (
  typeid int unsigned not null auto_increment,
  primary key (typeid),
  shortcode varchar(255),
  name varchar(255),
  type int,
  parent int,
  category int,
  clientid int default 1,
  menu_image text default null
)";

$query23 = "CREATE TABLE IF NOT EXISTS file_count(
  countid int unsigned not null auto_increment,
  primary key (countid),
  type varchar(20),
  number int,
  clientid int
)";

$query24 = "CREATE TABLE IF NOT EXISTS account_chart (
  typeid int unsigned not null auto_increment,
  primary key (typeid),
  account_id varchar(50),
  account_type int,
  account_name varchar(255),
  inactive varchar(10),
  clientid int
)";

$query25 = "CREATE TABLE IF NOT EXISTS transactions (
  tid varchar(300) NOT NULL,
  PRIMARY KEY (tid),
  serial_no int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
  KEY (serial_no),
  it_id int(11) DEFAULT NULL,
  it_type varchar(100)  DEFAULT NULL,
  itemid varchar(100)  DEFAULT NULL,
  description varchar(255)  DEFAULT NULL,
  trans_no varchar(100) NOT NULL,
  trans_type varchar(50)  DEFAULT NULL,
  type int(11) DEFAULT NULL,
  ref varchar(100)  DEFAULT NULL,
  method varchar(100)  DEFAULT NULL,
  cid varchar(100)  DEFAULT NULL,
  cref varchar(100)  DEFAULT NULL,
  c_type int(11) DEFAULT NULL,
  customer varchar(255)  DEFAULT NULL,
  customerPO varchar(255)  DEFAULT NULL,
  telephone varchar(50)  DEFAULT NULL,
  email varchar(255)  DEFAULT NULL,
  gender varchar(6)  DEFAULT NULL,
  address varchar(255)  DEFAULT NULL,
  city varchar(255)  DEFAULT NULL,
  state varchar(255)  DEFAULT NULL,
  zipcode varchar(255)  DEFAULT NULL,
  country varchar(255)  DEFAULT NULL,
  quantity decimal(12,0) DEFAULT NULL,
  gl_quantity decimal(12,2) DEFAULT NULL,
  sub int(11) DEFAULT NULL,
  parent varchar(300) DEFAULT 0,
  subdivision decimal(12,2) DEFAULT NULL,
  unit varchar(20)  DEFAULT NULL,
  rate decimal(14,2) DEFAULT NULL,
  amount decimal(14,2) DEFAULT NULL,
  gl_amount decimal(14,2) DEFAULT NULL,
  amount_paid decimal(14,2) DEFAULT NULL,
  amount_due decimal(14,2) DEFAULT NULL,
  net_due decimal(14,2) DEFAULT NULL,
  discount decimal(14,2) DEFAULT NULL,
  applied_credit decimal(14,2) DEFAULT NULL,
  wid int(11) DEFAULT NULL,
  warehouse varchar(255)  DEFAULT NULL,
  widto int(11) DEFAULT NULL,
  warehouseto varchar(255)  DEFAULT NULL,
  sign int(11) DEFAULT NULL,
  account varchar(100)  DEFAULT NULL,
  account_id int(11) DEFAULT NULL,
  account_name varchar(255)  DEFAULT NULL,
  account_type int(11) DEFAULT NULL,
  jid int(11) DEFAULT 0,
  jdesc text  DEFAULT NULL,
  prepayment int(11) DEFAULT NULL,
  status int(11) NOT NULL DEFAULT 0,
  created_by int(11) NOT NULL DEFAULT 0,
  updated_by int(11) NOT NULL DEFAULT 0,
  clientid int(11) NOT NULL DEFAULT 0,
  shipped tinyint(4) NOT NULL DEFAULT 0,
  date_due datetime DEFAULT CURRENT_TIMESTAMP,
  date_created datetime DEFAULT CURRENT_TIMESTAMP,
  date_updated datetime DEFAULT CURRENT_TIMESTAMP
)";

?>
