-- phpMyAdmin SQL Dump
-- version 4.9.4
-- https://www.phpmyadmin.net/
--
-- Host: localhost:3306
-- Generation Time: Jul 01, 2020 at 02:11 PM
-- Server version: 5.6.41-84.1
-- PHP Version: 7.3.6

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET AUTOCOMMIT = 0;
START TRANSACTION;
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

--
-- Database: `judanclo_thelordsexpress`
--

-- --------------------------------------------------------

--
-- Table structure for table `account_chart`
--

CREATE TABLE `account_chart` (
  `typeid` int(10) UNSIGNED NOT NULL,
  `account_id` varchar(50) DEFAULT NULL,
  `account_type` int(11) DEFAULT NULL,
  `account_name` varchar(255) DEFAULT NULL,
  `inactive` varchar(10) DEFAULT NULL,
  `clientid` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `activitylog`
--

CREATE TABLE `activitylog` (
  `id` int(11) UNSIGNED NOT NULL,
  `user_id` int(50) DEFAULT NULL,
  `action` varchar(250) DEFAULT NULL,
  `type` varchar(10) DEFAULT 'admin',
  `location` varchar(250) DEFAULT NULL,
  `location_id` varchar(50) DEFAULT NULL,
  `description` varchar(250) DEFAULT NULL,
  `date` datetime DEFAULT CURRENT_TIMESTAMP
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `activitylog`
--

INSERT INTO `activitylog` (`id`, `user_id`, `action`, `type`, `location`, `location_id`, `description`, `date`) VALUES
(1, 1, 'login', 'admin', 'users', NULL, 'Developer signed in', '2020-06-24 04:33:31'),
(2, 1, 'updated', 'admin', 'company_info', '1', 'Developer updated The lord\'s Express in Settings', '2020-06-24 04:35:27'),
(3, 1, 'updated', 'admin', 'company_info', '1', 'Developer updated  Home Page Slider', '2020-06-24 04:36:20'),
(4, 1, 'created', 'admin', 'content', '0', 'Developer created Enugu (Abakaliki Road) in Locations', '2020-06-24 04:37:56'),
(5, 1, 'created', 'admin', 'content', '0', 'Developer created Lagos (Mushin) in Locations', '2020-06-24 04:38:42'),
(6, 1, 'created', 'admin', 'users', '0', 'Developer created Ekaete in Drivers', '2020-06-24 04:39:20'),
(7, 1, 'created', 'admin', 'vehicle_type', '0', 'Developer created Toyota Sienna in Vehicles', '2020-06-24 04:39:35'),
(8, 1, 'created', 'admin', 'trip', '0', 'Developer created AC Ride with about 8hrs of ride in Trips', '2020-06-24 04:40:10'),
(9, 1, 'created', 'admin', 'trip', '0', 'Developer created AC Ride with about 8hrs of ride in Trips', '2020-06-24 04:40:37');

-- --------------------------------------------------------

--
-- Table structure for table `category_type`
--

CREATE TABLE `category_type` (
  `typeid` int(10) UNSIGNED NOT NULL,
  `shortcode` varchar(255) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `type` int(11) DEFAULT NULL,
  `parent` int(11) DEFAULT NULL,
  `category` int(11) DEFAULT NULL,
  `clientid` int(11) DEFAULT '1',
  `menu_image` text
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `company_info`
--

CREATE TABLE `company_info` (
  `id` int(10) UNSIGNED NOT NULL,
  `name` varchar(250) DEFAULT NULL,
  `logo_ref` text,
  `website` varchar(250) DEFAULT NULL,
  `email` varchar(250) DEFAULT NULL,
  `phone` varchar(15) DEFAULT NULL,
  `address` varchar(250) DEFAULT NULL,
  `other` text,
  `slider` text,
  `branches` text
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `company_info`
--

INSERT INTO `company_info` (`id`, `name`, `logo_ref`, `website`, `email`, `phone`, `address`, `other`, `slider`, `branches`) VALUES
(1, 'The lord\'s Express', '[{\"title\":\"The lords express Logo\",\"desc\":\"Logo<br>\",\"src\":\"https://mylelo.com/img/logo.jpg\",\"type\":\"picture\",\"id\":\"img_img\"},{\"title\":\"favicon\",\"desc\":\"The Lords express favicon<br>\",\"src\":\"https://mylelo.com/img/footer_logo.png\",\"type\":\"picture\",\"id\":\"img_img\"}]', 'https://thelordsexpress.com', 'info@thelordsexpress.com', '07034458314', 'The Lord\'s Express Transport 35, Abakaliki road, GRA, Enugu, Nigeria', NULL, '[{\"title\":\"Welcome\",\"desc\":\"to a home<br>\",\"src\":\"https://mylelo.com/img/banner/2019-toyota-sienna-exterior.jpg\",\"type\":\"picture\",\"id\":\"img_img\"}]', '[]');

-- --------------------------------------------------------

--
-- Table structure for table `content`
--

CREATE TABLE `content` (
  `id` int(10) UNSIGNED NOT NULL,
  `title` varchar(250) DEFAULT NULL,
  `body` longtext,
  `image` text,
  `view` varchar(250) DEFAULT NULL,
  `category` varchar(250) DEFAULT NULL,
  `industry` varchar(250) DEFAULT NULL,
  `business` varchar(250) DEFAULT NULL,
  `product` varchar(250) DEFAULT NULL,
  `product_desc` text,
  `parent` varchar(250) DEFAULT NULL,
  `label` varchar(250) DEFAULT NULL,
  `type` text,
  `auto` varchar(255) DEFAULT NULL,
  `status` int(11) DEFAULT '0',
  `no_of_views` int(11) DEFAULT '0',
  `user_id` int(50) DEFAULT '0',
  `author` int(50) DEFAULT NULL,
  `date_uploaded` datetime DEFAULT CURRENT_TIMESTAMP,
  `date_updated` datetime DEFAULT CURRENT_TIMESTAMP
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `content`
--

INSERT INTO `content` (`id`, `title`, `body`, `image`, `view`, `category`, `industry`, `business`, `product`, `product_desc`, `parent`, `label`, `type`, `auto`, `status`, `no_of_views`, `user_id`, `author`, `date_uploaded`, `date_updated`) VALUES
(1, 'Enugu (Abakaliki Road)', '[{\"src\":\"icons/assistant.svg\",\"title\":\"Phone\",\"desc\":\"07034458310\"}]', 'https://mylelo.com/img/instagram/6.png', '', NULL, NULL, NULL, NULL, NULL, NULL, '13', 'location', NULL, 1, 0, 0, NULL, '2020-06-24 04:37:56', '2020-06-24 04:37:56'),
(2, 'Lagos (Mushin)', '[{\"src\":\"icons/assistant.svg\",\"title\":\"Phone\",\"desc\":\"07034458310\"}]', 'https://mylelo.com/img/instagram/4.png', '6.4619206,7.5028951', NULL, NULL, NULL, NULL, NULL, NULL, '24', 'location', NULL, 1, 0, 0, NULL, '2020-06-24 04:38:42', '2020-06-24 04:38:42');

-- --------------------------------------------------------

--
-- Table structure for table `conversation`
--

CREATE TABLE `conversation` (
  `id` int(10) UNSIGNED NOT NULL,
  `post_id` int(50) DEFAULT NULL,
  `user_id` int(50) DEFAULT NULL,
  `parent_message` int(11) DEFAULT NULL,
  `title` varchar(250) DEFAULT NULL,
  `message` text,
  `type` varchar(250) DEFAULT NULL,
  `user_name` varchar(250) DEFAULT NULL,
  `time` datetime DEFAULT CURRENT_TIMESTAMP
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `courier`
--

CREATE TABLE `courier` (
  `package_ref` varchar(100) NOT NULL,
  `serial_no` int(11) UNSIGNED NOT NULL,
  `sender_name` varchar(50) DEFAULT NULL,
  `sender_phone` varchar(50) DEFAULT NULL,
  `sender_address` varchar(50) DEFAULT NULL,
  `sender_location` varchar(15) DEFAULT NULL,
  `receiver_name` varchar(50) DEFAULT NULL,
  `receiver_phone` varchar(50) DEFAULT NULL,
  `receiver_address` varchar(50) DEFAULT NULL,
  `receiver_location` varchar(15) DEFAULT NULL,
  `package_image` text,
  `package_desc` text,
  `package_weight` varchar(10) DEFAULT NULL,
  `package_cost` varchar(10) DEFAULT NULL,
  `track_progress` varchar(20) DEFAULT NULL,
  `trip_ref` varchar(255) NOT NULL,
  `driver_name` varchar(50) DEFAULT NULL,
  `vehicle_number` varchar(10) DEFAULT NULL,
  `user_id` int(11) DEFAULT '0',
  `status` tinyint(4) DEFAULT '0',
  `date_created` datetime DEFAULT CURRENT_TIMESTAMP
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `customer`
--

CREATE TABLE `customer` (
  `cId` int(10) UNSIGNED NOT NULL,
  `transcid` varchar(50) DEFAULT NULL,
  `customername` varchar(255) DEFAULT NULL,
  `contact` varchar(255) DEFAULT NULL,
  `address` varchar(255) DEFAULT NULL,
  `address2` varchar(255) DEFAULT NULL,
  `gender` varchar(6) DEFAULT NULL,
  `city` varchar(255) DEFAULT NULL,
  `state` varchar(255) DEFAULT NULL,
  `zipcode` varchar(255) DEFAULT NULL,
  `country` varchar(255) DEFAULT NULL,
  `telephone` varchar(50) DEFAULT NULL,
  `telephone1` varchar(50) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `website` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `sales_tax_code` varchar(255) DEFAULT NULL,
  `latlng` varchar(255) DEFAULT NULL,
  `wid` int(11) DEFAULT NULL,
  `warehouse` varchar(255) DEFAULT NULL,
  `shipping_details` text,
  `others` text,
  `publish` int(11) DEFAULT NULL,
  `type` varchar(100) DEFAULT NULL,
  `inactive` varchar(10) DEFAULT NULL,
  `prospect` varchar(10) DEFAULT NULL,
  `picture` varchar(255) DEFAULT NULL,
  `referal` varchar(255) DEFAULT NULL,
  `sales_representative_id` varchar(255) DEFAULT NULL,
  `gl_sales_account` varchar(255) DEFAULT NULL,
  `ship_via` varchar(255) DEFAULT NULL,
  `pricing_level` int(11) DEFAULT NULL,
  `use_standard_terms` varchar(10) DEFAULT NULL,
  `cod_terms` varchar(10) DEFAULT NULL,
  `prepaid_terms` varchar(10) DEFAULT NULL,
  `terms_type` varchar(10) DEFAULT NULL,
  `due_days` int(11) DEFAULT NULL,
  `discount_days` int(11) DEFAULT NULL,
  `discount_percent` float(12,2) DEFAULT NULL,
  `credit_limit` float(12,2) DEFAULT NULL,
  `charge_finance_charges` varchar(10) DEFAULT NULL,
  `due_month_end_terms` varchar(10) DEFAULT NULL,
  `cardholder_name` varchar(255) DEFAULT NULL,
  `credit_card_address1` varchar(255) DEFAULT NULL,
  `credit_card_address2` varchar(255) DEFAULT NULL,
  `credit_card_city` varchar(255) DEFAULT NULL,
  `credit_card_state` varchar(255) DEFAULT NULL,
  `credit_card_zip_code` varchar(255) DEFAULT NULL,
  `credit_card_country` varchar(255) DEFAULT NULL,
  `credit_card_number` varchar(255) DEFAULT NULL,
  `credit_card_expiration_date` varchar(255) DEFAULT NULL,
  `current_balance` float(10,2) DEFAULT NULL,
  `punit` varchar(50) DEFAULT NULL,
  `created_by` int(11) DEFAULT NULL,
  `clientid` int(11) DEFAULT NULL,
  `customer_password` varchar(100) DEFAULT NULL,
  `customer_since` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `last_login` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `default_account_settings`
--

CREATE TABLE `default_account_settings` (
  `sid` int(10) UNSIGNED NOT NULL,
  `account_receivable` varchar(255) DEFAULT NULL,
  `other_receivable` varchar(255) DEFAULT NULL,
  `account_payable` varchar(255) DEFAULT NULL,
  `other_payable` varchar(255) DEFAULT NULL,
  `cash` varchar(255) DEFAULT NULL,
  `sales` varchar(255) DEFAULT NULL,
  `cost_of_sales` varchar(255) DEFAULT NULL,
  `fixed_assets` varchar(255) DEFAULT NULL,
  `other_assets` varchar(255) DEFAULT NULL,
  `expenses` varchar(255) DEFAULT NULL,
  `current_assets` varchar(255) DEFAULT NULL,
  `current_liabilities` varchar(255) DEFAULT NULL,
  `long_term_liabilities` varchar(255) DEFAULT NULL,
  `equity_open` varchar(255) DEFAULT NULL,
  `equity_closed` varchar(255) DEFAULT NULL,
  `equity_retained` varchar(255) DEFAULT NULL,
  `inventory` varchar(255) DEFAULT NULL,
  `accumulated_depreciation` varchar(255) DEFAULT NULL,
  `payroll` varchar(255) DEFAULT NULL,
  `discount` varchar(255) DEFAULT NULL,
  `pur_discount` varchar(255) DEFAULT NULL,
  `production` varchar(255) DEFAULT NULL,
  `clientid` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `file_count`
--

CREATE TABLE `file_count` (
  `countid` int(10) UNSIGNED NOT NULL,
  `type` varchar(20) DEFAULT NULL,
  `number` int(11) DEFAULT NULL,
  `clientid` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `roles`
--

CREATE TABLE `roles` (
  `roleid` int(10) UNSIGNED NOT NULL,
  `transcid` varchar(50) DEFAULT NULL,
  `rolename` varchar(255) DEFAULT NULL,
  `roledesc` text,
  `clientid` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `roles`
--

INSERT INTO `roles` (`roleid`, `transcid`, `rolename`, `roledesc`, `clientid`) VALUES
(1, '1592994661367', 'Administrator', '1:1,2:1,2:2,3:1,3:2,3:3,3:4,4:1,4:2,4:3,5:1,5:2,5:3,5:4,6:1,6:2,7:1,7:2', 1);

-- --------------------------------------------------------

--
-- Table structure for table `subscribers`
--

CREATE TABLE `subscribers` (
  `id` int(10) UNSIGNED NOT NULL,
  `name` varchar(250) DEFAULT NULL,
  `email` varchar(250) DEFAULT NULL,
  `user_id` int(50) DEFAULT NULL,
  `status` int(20) DEFAULT '1',
  `sub_date` datetime DEFAULT CURRENT_TIMESTAMP,
  `unsub_date` datetime DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `tracking`
--

CREATE TABLE `tracking` (
  `id` int(10) UNSIGNED NOT NULL,
  `track_number` varchar(50) DEFAULT NULL,
  `description` varchar(300) DEFAULT NULL,
  `track_index` tinyint(4) DEFAULT NULL,
  `user_id` int(11) DEFAULT '0',
  `date_created` datetime DEFAULT CURRENT_TIMESTAMP
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `transactions`
--

CREATE TABLE `transactions` (
  `tid` varchar(300) NOT NULL,
  `serial_no` int(11) UNSIGNED NOT NULL,
  `it_id` int(11) DEFAULT NULL,
  `it_type` varchar(100) DEFAULT NULL,
  `itemid` varchar(100) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `trans_no` varchar(100) NOT NULL,
  `trans_type` varchar(50) DEFAULT NULL,
  `type` int(11) DEFAULT NULL,
  `ref` varchar(100) DEFAULT NULL,
  `method` varchar(100) DEFAULT NULL,
  `cid` varchar(100) DEFAULT NULL,
  `cref` varchar(100) DEFAULT NULL,
  `c_type` int(11) DEFAULT NULL,
  `customer` varchar(255) DEFAULT NULL,
  `customerPO` varchar(255) DEFAULT NULL,
  `telephone` varchar(50) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `gender` varchar(6) DEFAULT NULL,
  `address` varchar(255) DEFAULT NULL,
  `city` varchar(255) DEFAULT NULL,
  `state` varchar(255) DEFAULT NULL,
  `zipcode` varchar(255) DEFAULT NULL,
  `country` varchar(255) DEFAULT NULL,
  `quantity` decimal(12,0) DEFAULT NULL,
  `gl_quantity` decimal(12,2) DEFAULT NULL,
  `sub` int(11) DEFAULT NULL,
  `parent` varchar(300) DEFAULT '0',
  `subdivision` decimal(12,2) DEFAULT NULL,
  `unit` varchar(20) DEFAULT NULL,
  `rate` decimal(14,2) DEFAULT NULL,
  `amount` decimal(14,2) DEFAULT NULL,
  `gl_amount` decimal(14,2) DEFAULT NULL,
  `amount_paid` decimal(14,2) DEFAULT NULL,
  `amount_due` decimal(14,2) DEFAULT NULL,
  `net_due` decimal(14,2) DEFAULT NULL,
  `discount` decimal(14,2) DEFAULT NULL,
  `applied_credit` decimal(14,2) DEFAULT NULL,
  `wid` int(11) DEFAULT NULL,
  `warehouse` varchar(255) DEFAULT NULL,
  `widto` int(11) DEFAULT NULL,
  `warehouseto` varchar(255) DEFAULT NULL,
  `sign` int(11) DEFAULT NULL,
  `account` varchar(100) DEFAULT NULL,
  `account_id` int(11) DEFAULT NULL,
  `account_name` varchar(255) DEFAULT NULL,
  `account_type` int(11) DEFAULT NULL,
  `jid` int(11) DEFAULT '0',
  `jdesc` text,
  `prepayment` int(11) DEFAULT NULL,
  `status` int(11) NOT NULL DEFAULT '0',
  `created_by` int(11) NOT NULL DEFAULT '0',
  `updated_by` int(11) NOT NULL DEFAULT '0',
  `clientid` int(11) NOT NULL DEFAULT '0',
  `shipped` tinyint(4) NOT NULL DEFAULT '0',
  `date_due` datetime DEFAULT CURRENT_TIMESTAMP,
  `date_created` datetime DEFAULT CURRENT_TIMESTAMP,
  `date_updated` datetime DEFAULT CURRENT_TIMESTAMP
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `trip`
--

CREATE TABLE `trip` (
  `id` int(10) UNSIGNED NOT NULL,
  `departure_id` int(11) DEFAULT NULL,
  `departure` varchar(255) DEFAULT NULL,
  `arrival_id` int(11) DEFAULT NULL,
  `arrival` varchar(255) DEFAULT NULL,
  `description` text,
  `vehicle_type` varchar(10) DEFAULT NULL,
  `days` varchar(255) DEFAULT NULL,
  `departure_time` time DEFAULT NULL,
  `price` decimal(12,2) DEFAULT NULL,
  `price2` decimal(12,2) DEFAULT NULL,
  `date_created` datetime DEFAULT CURRENT_TIMESTAMP,
  `date_updated` datetime DEFAULT CURRENT_TIMESTAMP
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `trip`
--

INSERT INTO `trip` (`id`, `departure_id`, `departure`, `arrival_id`, `arrival`, `description`, `vehicle_type`, `days`, `departure_time`, `price`, `price2`, `date_created`, `date_updated`) VALUES
(1, 1, 'Enugu (Abakaliki Road)', 2, 'Lagos (Mushin)', 'AC Ride with about 8hrs of ride', 'sienna', '1,2,3,4,5,6', '06:30:00', 1500.00, 1300.00, '2020-06-24 04:40:10', '2020-06-24 04:40:10'),
(2, 2, 'Lagos (Mushin)', 1, 'Enugu (Abakaliki Road)', 'AC Ride with about 8hrs of ride', 'sienna', '1,2,3,4', '08:30:00', 30000.00, 25000.00, '2020-06-24 04:40:37', '2020-06-24 04:40:37');

-- --------------------------------------------------------

--
-- Table structure for table `users`
--

CREATE TABLE `users` (
  `id` int(10) UNSIGNED NOT NULL,
  `picture_ref` varchar(255) DEFAULT NULL,
  `first_name` varchar(255) NOT NULL,
  `middle_name` varchar(255) DEFAULT NULL,
  `last_name` varchar(255) DEFAULT NULL,
  `phone` varchar(70) DEFAULT NULL,
  `email` varchar(70) DEFAULT NULL,
  `state` varchar(70) DEFAULT NULL,
  `gender` varchar(6) DEFAULT NULL,
  `username` varchar(50) NOT NULL,
  `password` text NOT NULL,
  `bio` varchar(300) DEFAULT NULL,
  `type` int(5) DEFAULT NULL,
  `status` int(5) DEFAULT '0',
  `roleId` int(11) DEFAULT '0',
  `accessLevel` int(11) DEFAULT '0',
  `address` varchar(255) DEFAULT NULL,
  `website` varchar(255) DEFAULT NULL,
  `other` varchar(255) DEFAULT NULL,
  `dob` datetime DEFAULT CURRENT_TIMESTAMP,
  `date` datetime DEFAULT CURRENT_TIMESTAMP
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `users`
--

INSERT INTO `users` (`id`, `picture_ref`, `first_name`, `middle_name`, `last_name`, `phone`, `email`, `state`, `gender`, `username`, `password`, `bio`, `type`, `status`, `roleId`, `accessLevel`, `address`, `website`, `other`, `dob`, `date`) VALUES
(1, NULL, 'Developer', NULL, 'Digital Dreams', NULL, 'info@digitaldreamsng.com', NULL, NULL, 'administrator', 'email@admin', NULL, 1, 1, 1, 2, NULL, NULL, NULL, '2020-06-24 04:31:01', '2020-06-24 04:31:01'),
(2, 'https://mylelo.com/img/instagram/6.png', 'Ekaete', NULL, 'Muna', '234908539998', 'defunmi6@gmail.com', NULL, NULL, '********', '*******', NULL, 2, 1, 0, 0, NULL, NULL, NULL, '2020-06-24 04:39:20', '2020-06-24 04:39:20');

-- --------------------------------------------------------

--
-- Table structure for table `vehicle_type`
--

CREATE TABLE `vehicle_type` (
  `id` int(10) UNSIGNED NOT NULL,
  `name` varchar(255) DEFAULT NULL,
  `seat_number` varchar(50) DEFAULT NULL,
  `picture` varchar(255) DEFAULT NULL,
  `description` text,
  `facilty` text,
  `seat_map` varchar(255) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `vehicle_type`
--

INSERT INTO `vehicle_type` (`id`, `name`, `seat_number`, `picture`, `description`, `facilty`, `seat_map`) VALUES
(1, 'Toyota Sienna', '8556SAKIJ', '', '[]', '2', 'sienna');

--
-- Indexes for dumped tables
--

--
-- Indexes for table `account_chart`
--
ALTER TABLE `account_chart`
  ADD PRIMARY KEY (`typeid`);

--
-- Indexes for table `activitylog`
--
ALTER TABLE `activitylog`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `category_type`
--
ALTER TABLE `category_type`
  ADD PRIMARY KEY (`typeid`);

--
-- Indexes for table `company_info`
--
ALTER TABLE `company_info`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `content`
--
ALTER TABLE `content`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `conversation`
--
ALTER TABLE `conversation`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `courier`
--
ALTER TABLE `courier`
  ADD PRIMARY KEY (`serial_no`),
  ADD KEY `package_ref` (`package_ref`);

--
-- Indexes for table `customer`
--
ALTER TABLE `customer`
  ADD PRIMARY KEY (`cId`);

--
-- Indexes for table `default_account_settings`
--
ALTER TABLE `default_account_settings`
  ADD PRIMARY KEY (`sid`);

--
-- Indexes for table `file_count`
--
ALTER TABLE `file_count`
  ADD PRIMARY KEY (`countid`);

--
-- Indexes for table `roles`
--
ALTER TABLE `roles`
  ADD PRIMARY KEY (`roleid`);

--
-- Indexes for table `subscribers`
--
ALTER TABLE `subscribers`
  ADD PRIMARY KEY (`id`),
  ADD UNIQUE KEY `email` (`email`);

--
-- Indexes for table `tracking`
--
ALTER TABLE `tracking`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `transactions`
--
ALTER TABLE `transactions`
  ADD PRIMARY KEY (`tid`),
  ADD KEY `serial_no` (`serial_no`);

--
-- Indexes for table `trip`
--
ALTER TABLE `trip`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `users`
--
ALTER TABLE `users`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `vehicle_type`
--
ALTER TABLE `vehicle_type`
  ADD PRIMARY KEY (`id`);

--
-- AUTO_INCREMENT for dumped tables
--

--
-- AUTO_INCREMENT for table `account_chart`
--
ALTER TABLE `account_chart`
  MODIFY `typeid` int(10) UNSIGNED NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `activitylog`
--
ALTER TABLE `activitylog`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=10;

--
-- AUTO_INCREMENT for table `category_type`
--
ALTER TABLE `category_type`
  MODIFY `typeid` int(10) UNSIGNED NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `company_info`
--
ALTER TABLE `company_info`
  MODIFY `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;

--
-- AUTO_INCREMENT for table `content`
--
ALTER TABLE `content`
  MODIFY `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3;

--
-- AUTO_INCREMENT for table `conversation`
--
ALTER TABLE `conversation`
  MODIFY `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `courier`
--
ALTER TABLE `courier`
  MODIFY `serial_no` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `customer`
--
ALTER TABLE `customer`
  MODIFY `cId` int(10) UNSIGNED NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `default_account_settings`
--
ALTER TABLE `default_account_settings`
  MODIFY `sid` int(10) UNSIGNED NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `file_count`
--
ALTER TABLE `file_count`
  MODIFY `countid` int(10) UNSIGNED NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `roles`
--
ALTER TABLE `roles`
  MODIFY `roleid` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;

--
-- AUTO_INCREMENT for table `subscribers`
--
ALTER TABLE `subscribers`
  MODIFY `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `tracking`
--
ALTER TABLE `tracking`
  MODIFY `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `transactions`
--
ALTER TABLE `transactions`
  MODIFY `serial_no` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `trip`
--
ALTER TABLE `trip`
  MODIFY `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3;

--
-- AUTO_INCREMENT for table `users`
--
ALTER TABLE `users`
  MODIFY `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3;

--
-- AUTO_INCREMENT for table `vehicle_type`
--
ALTER TABLE `vehicle_type`
  MODIFY `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;
COMMIT;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
