<?php
$actions = [
	"barcode"=>[
		'table'=>'item',
		'primary_key'=>'tid',
		'page_title'=>'Print Barcode',
		'icon'=>'print_black',
		//'fixed_values'=>"",
		//'extra_values'=>"last_updated=now()",
		//'retrieve_filter'=>"",
		'process_url'=>'process_barcode.php',
		'submit_type'=>'print',
		'actionCol'=>'upc',
		'form'=>[
			'sections'=>[
				[
					'position'=>'center',
					'section_title'=>'Print Barcode',
					'section_elements'=>[
						[
							'column'=>'message',
							'description'=>'Print Barcode of selected products',
							'type'=>'content',
							'class'=>'col s12 m12'
						]
					]
				]
			]
		]
	],
	"print"=>[
		"table"=>"item",
		"primary_key"=>"tid",
		"page_title"=>"Print Receipt",
		"icon"=>"print_black",
		"form"=>[
			"form_view"=>"print_Form"
		]
	],

	"Emailsubscribers"=>[
		'table'=>'subscribers',
		'primary_key'=>'id',
		'page_title'=>'Emailsubscribers',
		'icon'=>'email',
		'fixed_values'=>"",
		'process_url'=>'process_bulk_email.php',
		'actionCol'=>'email',
		'form'=>[
			'sections'=>[
				[
					'position'=>'center',
					'section_title'=>'Send Email to selected Subscribers',
					'section_elements'=>[
						[
							'column'=>'subject',
							'description'=>'Subject',
							'type'=>'text',
							'required'=>true,
							'class'=>'col s12 m12'
						],[
							'column'=>'message',
							'description'=>'Message',
							'type'=>'textarea',
							'required'=>true,
							'class'=>'col s12 m12'
						]
					]
				]
			]
		]
	]
];
?>
