$.fn.extend({
  reviewCourse: function () {
    const widget = this, container = $('<div>').addClass('container').appendTo(widget), verifyRow = $('<div>').addClass('row').appendTo(container);
    $('<div>').addClass('col s12').appendTo(verifyRow).append($('<div>').addClass('switch').append($('<label>').text('Reject').append($('<input>').attr({type: 'checkbox', disabled: true, id: 'approveCourseSwitch'})).append($('<span>').addClass('lever')).append('Approve')))
  },
  loadCourseContent: function (fields) {
    if (fields.in_review == 1) {
      $(this).prop('in_review', true);
      $('#approveCourseSwitch').prop({checked: false, disabled: false});
    } else {
      $('#approveCourseSwitch').prop({checked: true, disabled: false, readonly: true});
    }
  },
  shouldPublishChanges: function () {
    if ($(this).prop('in_review')) {
      $(this).removeProp('in_review');
      return $('#approveCourseSwitch').is(':checked');
    }
    return false;
  },
})