<?php
$lists = listCache($uri->page_source, $uri->content_id);
$latest = array_range($lists, 3);
?>
<!DOCTYPE html>
<html lang="">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">

<title>Insights | Digital Dreams LTD</title>
<?php require_once("components/csslinks.php")?>
</head>
<body>
<?php require_once("components/nav.php")?>

	<div class='float-left posRel fullWidth'>
		<div id="carouselExampleIndicators" class="carousel slide not-full"  data-ride="carousel">
        <ol class="carousel-indicators">
					<?php if(count($latest) > 1){ foreach($latest as $k => $image){?>
					<li data-target="#carouselExampleIndicators" data-slide-to="<?=$k?>" class="<?php if($k==0)echo 'active'; ?>"></li>
					<?php } }?>
        </ol>
        <div class="carousel-inner" role="listbox">
          <?php foreach($latest as $k => $article){?>
						<div class="carousel-item <?php if($k==0)echo ' active'; ?>">
              <div class="float-right posAbs" style="right: 10%;width: 70%;z-index: 1; top: 25%">
                  <a href="<?=$uri->site?>article/<?=$article->id?>-<?=$article->url?>">
										<h1 class="text_bold_7 text-white text-right animated bounceInUp" style="text-shadow: 1px 1px 1px black;animation-delay: 0.01s;animation-duration: 1.5s; text-transform: uppercase">
											<?=$article->title?>
										</h1>
									</a>
              </div>
              <div class="custom-overlay posAbs float-left fullWidth fullHeight"></div>
              <img class="d-block" src="<?=$article->image->src?>" alt="First slide">
            </div>
					<?php } ?>
        </div>
        <?php if(count($latest) > 1){?>
					<a class="carousel-control-prev" href="#carouselExampleIndicators" role="button" data-slide="prev">
            <i class="now-ui-icons arrows-1_minimal-left"></i>
        	</a>
	        <a class="carousel-control-next" href="#carouselExampleIndicators" role="button" data-slide="next">
	            <i class="now-ui-icons arrows-1_minimal-right"></i>
	        </a>
				<?php } ?>
    </div>
	</div>

	<div class="col-md-12 posRel float-left list-one">

    <?php
		for($k = 0; $k < 10; $k++ ){
			if(isset($lists[$k])){ $item = $lists[$k];?>
				<div class="col-md-6 col-sm-12 posRel float-left animated nopad-mobile">
					<div class="padd">
						<?php require('components/card_horizontal.php');?>
					</div>
				</div>
			 <?php }
		}if(isset($lists[10])){ $item = $lists[10]; $k = rand(0, 20);?>
			<div class="col-sm-12 posRel float-left animated nopad-mobile" style="margin-top: 15px">
				<?php require('components/card_curvy.php');?>
			</div>
		<?php

			for($ik = 10; $ik <= count($lists); $ik++ ){
				if(isset($lists[$ik])){$item = $lists[$ik];?>
					<div class="col-md-6 col-sm-12 posRel float-left animated nopad-mobile">
						<div class="padd">
							<?php require('components/card_horizontal.php');?>
						</div>
					</div>
			 	<?php }
			}
		}
	?>
	</div>
<?php require_once("components/footer.php")?>
<script async src="//pagead2.googlesyndication.com/pagead/js/adsbygoogle.js"></script>
<script>


(adsbygoogle = window.adsbygoogle || []).push({
google_ad_client: "ca-pub-4696224049420135",
enable_page_level_ads: true
});(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
(i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
})(window,document,'script','//www.google-analytics.com/analytics.js','ga');
ga('create', 'UA-12843401-1', 'auto');
ga('require', 'displayfeatures');
ga('send', 'pageview');
</script>
</body>
</html>
