<?php
$data = get_homepage();
$page_data = $data->page_data;
$insights = $data->insights;
$products = $data->products;
?>
<!doctype html>
<html lang="">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">
<title>Web Developement - Digital Marketing - Mobile App Developement - ICT consultancy - ICT Training | Digital Dreams LTD</title>
<meta name="description" content="Digital Dreams LTD - Web Developement, Digital Marketing, Mobile App Developement, ICT consultancy, ICT Training">

<meta name="image" content="<?=reset($page_data->slider)->src?>">
<meta name="description" content="Digital Dreams LTD - Web Developement, Digital Marketing, Mobile App Developement, ICT consultancy, ICT Training" />
<meta itemprop="name" content="Digital Dreams LTD - Web Developement, Digital Marketing, Mobile App Developement, ICT consultancy, ICT Training">
<meta itemprop="description" content="Digital Dreams LTD - Web Developement, Digital Marketing, Mobile App Developement, ICT consultancy, ICT Training">
<meta itemprop="image" content="<?=reset($page_data->slider)->src?>">

<meta name="twitter:card" content="summary_large_image">
<meta name="twitter:title" content="Digital Dreams LTD - Web Developement, Digital Marketing, Mobile App Developement, ICT consultancy, ICT Training">
<meta name="twitter:description" content="Digital Dreams LTD - Web Developement, Digital Marketing, Mobile App Developement, ICT consultancy, ICT Training">
<meta name="twitter:site" content="@digitaldreamsng">
<meta name="twitter:image:src" content="<?=$company->logo_ref?>">
<meta name="og:url" content="<?=$uri->site;?>">
<meta name="og:site_name" content="Digital Dreams LTD">
<meta name="og:locale" content="en_US">
<meta name="og:type" content="website">
<meta name="article:section" content="ICT">

<?php require_once('components/csslinks.php') ?>

</head>
<body data-site="">

<?php require_once('components/nav.php')?>
<?php if(isset($_404) && $_404 === true){?>
	<div class="error_404"><div>The page you requested does not exist on our server <i class="now-ui-icons ui-1_simple-remove" onClick="$('.error_404').fadeOut('slow')"></i></div></div>
<?php }?>
<div class='float-left posRel fullWidth'>
    <div id="carouselExampleIndicators" class="carousel slide" data-ride="carousel">
        <ol class="carousel-indicators">
            <?php //$page_data = (object) $page_data;
						foreach($page_data->slider as $k => $image){?>
            	<li data-target="#carouselExampleIndicators" data-slide-to="<?=$k?>" class="<?php if($k==0)echo 'active'; ?>"></li>
            <?php } ?>
        </ol>
        <div class="carousel-inner" role="listbox">
            <?php foreach($page_data->slider as $k => $image){ //$image = (object) $image; ?>
							<div class="carousel-item <?php if($k==0)echo ' active'; ?>">
                <div class="float-right posAbs" style="padding: 50px; right: 0; margin: 120px 150px 0 0px;width: 600px;z-index: 1;">
                    <h1 class="site_title text_bold_7 text-white text-right animated bounceInUp" style="animation-delay: 0.01s;animation-duration: 1.5s;"><?=$image->title?></h1>
                    <h5 class="text-white text-right animated bounceInUp" style="font-weight:200; animation-delay: 0.11s;animation-duration: 1.5s;"><?=$image->desc?></h5>
                    <?php if(isset($image->anchor->href) && !empty($image->anchor->href)){ ?>
                    	<button href="<?=$image->anchor->href?>" class="btn btn-lg btn-info float-right animated bounceInUp" style="animation-delay: 0.21s;animation-duration: 1.5s;"><?= $image->anchor->name?></button>
					<?php }?>
                </div>
                <div class="custom-overlay posAbs float-left fullWidth fullHeight"></div>
                <img class="d-block" src="<?=str_replace("tbn/", "", $image->src)?>" alt="<?=$image->title?>">
                <div class="carousel-caption d-none d-md-block">
                    <h5>Digital Dreams Limited, Nigeria</h5>
                </div>
            </div>
			<?php } ?>
        </div>
        <?php if(count($page_data->slider) > 1){?>
		<a class="carousel-control-prev" href="#carouselExampleIndicators" role="button" data-slide="prev">
            <i class="now-ui-icons arrows-1_minimal-left"></i>
        </a>
        <a class="carousel-control-next" href="#carouselExampleIndicators" role="button" data-slide="next">
            <i class="now-ui-icons arrows-1_minimal-right"></i>
        </a>
		<?php } ?>
    </div>
</div>



<div class="fullWidth posRel float-left">
    <div class="brief float-left">
        <div class="posRel col-sm-12 float-left">
          <h2 class="text_bold_7 text-left text-capitalize mt-4 pl-3 pr-3">Thoughts around us</h2>
        </div>
        <?php foreach($insights as $k => $item){ ?>
				<div class="posRel col-lg-4 col-md-6 col-sm-12 noShadow float-left insight animated" >
					<?php	$item = (object) $item;// print_r($item);die();
					if($k < 6){
						require('components/card_vertical.php');
					}?>
				</div>
			<?php } ?>
    </div>
</div>

<hr class="style-two">

<div class="float-left posRel fullWidth overflow-h" style="min-height: 600px;margin-top: 100px">

	<div class="posRel">

		<div class="col-sm-12 col-md-10 mr-auto ml-auto" style="margin-bottom: 30px">
			<h2 class="text_bold_7 text-left">Overview of Digital Dreams Products</h2>
		</div>

		<div id="projects_slide" class="carousel slide" data-ride="carousel">
			<ol class="carousel-indicators">
				<?php //$products = (object) $products;
				foreach($products as $k => $image){?>
					<li data-target="#projects_slide" data-slide-to="<?=$k?>" class="<?php if($k==0)echo 'active'; ?>"></li>
				<?php } ?>
			</ol>
			<div class="carousel-inner" role="listbox" style="box-shadow: unset !important;">
				<?php foreach($products as $k => $product){?>
					<div class="carousel-item <?php if($k==0)echo ' active'; ?>">
						<div class="col-md-10 mr-auto ml-auto posi">
							<b class="capitalize text-left" style="font-size: 18px">
								<a href="<?=$uri->site?>product/<?=$product->id?>-<?=$product->url?>"><?= $product->title?></a>
							</b>
							<div class="col-md-5 float-left posRel" style="margin-bottom: 50px;">
								<img src="<?=str_replace("tbn/", "", str_replace("../", "", reset($product->image)->src))?>" alt="digital dreams" class="posRel float-left" style="width: unset; height: 330px !important">
							</div>
							<div class="col-md-7 specs" style="margin-bottom: 50px;">
								<?php foreach($product->product_desc as $k => $description){
									if($k <=2){$thum = str_replace("../", "", $description->src)?>
										<div class="posRel float-left project">
											<div class="posRel float-left icon" style="background-image: url('<?=$thum?>')"></div>
											<div class="posRel float-left description">
												<h4 class="text-black"><?=substr($description->title, 0, 30)?></h4>
												<p class="myGray text_bold_2"><?=substr(strip_tags($description->desc), 0, 50)?></p>
											</div>
										</div>
									<?php }
								} ?>
							</div>
						</div>
					</div>
				<?php } ?>
			</div>
			<?php if(count($products) > 1){?>
				<a class="carousel-control-prev" href="#projects_slide" role="button" data-slide="prev">
					<i class="now-ui-icons arrows-1_minimal-left"></i>
				</a>
				<a class="carousel-control-next" href="#projects_slide" role="button" data-slide="next">
					<i class="now-ui-icons arrows-1_minimal-right"></i>
				</a>
			<?php } ?>
		</div>
	</div>
</div>

<?php require_once('components/footer.php')?>
	</body>
</html>
