<?php
$id = explode("-", $uri->content_id); $id = reset($id);
$data = contentCache($uri->page_source, $id);
$lists = categoryCache($id, $uri->content_id);
$slider = reset($data->image);
$data->title .= ' | Digital Dreams LTD';
?>

<!doctype html>
<html lang="">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">
<title><?=$data->title;?></title>

<?php require_once("components/seo_tags.php")?>
<?php require_once("components/csslinks.php")?>
</head>
<body>
<?php require_once("components/nav.php")?>

<div class='float-left posRel fullWidth'>
  <div id="carouselExampleIndicators" class="carousel slide not-full" data-ride="carousel">
    <ol class="carousel-indicators">
        <?php foreach($data->image as $k => $image) {?>
        <li data-target="#carouselExampleIndicators" data-slide-to="<?=$k?>" class="<?php if($k==0)echo 'active'; ?>"></li>
        <?php } ?>
    </ol>
    <div class="carousel-inner" role="listbox" style="height:70vh">
      <?php
				foreach($data->image as $k => $image){
					list($width, $height)  = [500,300];//getimagesize(absolute_filepath($image->src));?>

					<div class="carousel-item <?php if($k==0)echo ' active'; ?>">
            <div class="float-right posAbs" style="padding: 50px; right: 0; margin: 120px 150px 0 0px;width: 600px;z-index: 1;">
                <h1 class="site_title text_bold_7 text-white text-right animated bounceInUp" style="animation-delay: 0.01s;animation-duration: 1.5s;"><?=$image->title?></h1>
                <h5 class="text-white text-right animated bounceInUp" style="font-weight:200; animation-delay: 0.11s;animation-duration: 1.5s;"><?=$image->desc?></h5>
                <?php if(!empty($image->anchor->href)){ ?>
                	<a href="<?=$image->anchor->href?>" class="btn btn-lg btn-info float-right animated bounceInUp" style="animation-delay: 0.21s;animation-duration: 1.5s;"><?=$image->anchor->name?></a>
								<?php }?>
            </div>
            <div class="custom-overlay posAbs float-left fullWidth fullHeight"></div>
            <img class="d-block <?php if($width > $height || $width==$height){echo 'slide-fh';}else echo 'slide-fw' ?>" src="<?=$image->src?>" alt="First slide">
        </div>
			<?php } ?>
    </div>
    <?php if(count($data->image) > 1){?>
			<a class="carousel-control-prev" href="#carouselExampleIndicators" role="button" data-slide="prev">
        <i class="now-ui-icons arrows-1_minimal-left"></i>
      </a>
      <a class="carousel-control-next" href="#carouselExampleIndicators" role="button" data-slide="next">
          <i class="now-ui-icons arrows-1_minimal-right"></i>
      </a>
		<?php } ?>
  </div>
</div>


<div class="col-md-12 posRel float-left list-one">
  <div class="posRel col-sm-12 float-left">
     <h3 class="text_bold_7 text-center text-capitalize mt-4 pl-3 pr-3"><?=ucwords($data->title)?></h3>
  </div>
  <hr class="style-two" style="margin-top: 0;">

  <?php if(empty($lists) || count($lists) == 0){ ?>
		<h4 class="container text-center">No article found for <?=ucwords($data->title)?></h4>
	<?php }else {
		for($k = 0; $k < 10; $k++ ){
			if(isset($lists[$k])){ $item = $lists[$k];?>
				<div class="col-md-6 col-sm-12 posRel float-left animated nopad-mobile">
					<div class="padd">
						<?php require('components/card_horizontal.php');?>
					</div>
				</div>
			 <?php }
		}if(isset($lists[10])){ $item = $lists[10]; $k = rand(0, 20);?>
			<div class="col-sm-12 posRel float-left animated nopad-mobile" style="margin-top: 15px">
				<?php require('components/card_curvy.php');?>
			</div>
		<?php

			for($ik = 10; $ik <= $count; $ik++ ){
				if(isset($lists[$ik])){$item = $lists[$ik];?>
					<div class="col-md-6 col-sm-12 posRel float-left animated nopad-mobile">
						<div class="padd">
							<?php require('components/card_horizontal.php');?>
						</div>
					</div>
			 	<?php }
			}
		}}?>


	</div>
	<?php require_once("components/footer.php")?>
</body>
</html>
