<?php
//header('Content-Type: application/json');
//articles, news, caseStudy
$related = [];
$id = explode("-", $uri->content_id);
$data = contentCache($uri->page_source, reset($id));

$slider = reset($data->image);
$data->title = strip_tags($data->title).' | Digital Dreams LTD';
?>
<!doctype html>
<html lang="">
<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta name="viewport" content="width=device-width, initial-scale=1">

	<title><?=$data->title;?></title>

	<?php require_once('components/seo_tags.php')?>
	<?php require_once('components/csslinks.php')?>
</head>
<body data-id="<?=$data->id?>" data-type="<?=$data->type?>">
	<?php require_once('components/nav.php')?>

	<div class='float-left posRel fullWidth'>
		<div id="carouselExampleIndicators" class="carousel slide not-full"  <?php if(count($data->image) == 1) echo 'style="height: 60vh"'?>  data-ride="carousel">
			<ol class="carousel-indicators">
				<?php if(count($data->image) > 1){ foreach($data->image as $k => $image){?>
					<li data-target="#carouselExampleIndicators" data-slide-to="<?=$k?>" class="<?php if($k==0)echo 'active'; ?>"></li>
				<?php } }?>
			</ol>
			<div class="carousel-inner" role="listbox">
				<?php foreach($data->image as $k => $image){?>
					<div class="carousel-item <?php if($k==0)echo ' active'; ?>">
						<div class="<?php if(count($data->image) < 2){echo('one-item');}?> float-right posAbs" style="right: 10%;width: 70%;z-index: 1; top: 25%">
							<h1 class="text_bold_7 text-white text-right animated bounceInUp" style="text-shadow: 1px 1px 1px black;animation-delay: 0.01s;animation-duration: 1.5s; text-transform: uppercase"><?php if(count($data->image) > 1){echo $image->title;}else{echo $data->title;}?></h1>
							<?php if(count($data->image) > 1){?><h5 class="text-white text-right animated bounceInUp" style="font-weight:200; animation-delay: 0.11s;animation-duration: 1.5s;"><?=$image->desc?></h5><?php }?>
							</div>
							<div class="custom-overlay posAbs float-left fullWidth fullHeight"></div>
							<img class="d-block" src="<?=str_replace('../', $uri->site, $image->src) ?>" alt="First slide">
						</div>
					<?php } ?>
				</div>
				<?php if(count($data->image) > 1){?>
					<a class="carousel-control-prev" href="#carouselExampleIndicators" role="button" data-slide="prev">
						<i class="now-ui-icons arrows-1_minimal-left"></i>
					</a>
					<a class="carousel-control-next" href="#carouselExampleIndicators" role="button" data-slide="next">
						<i class="now-ui-icons arrows-1_minimal-right"></i>
					</a>
				<?php } ?>
			</div>
		</div>

		<div class="read-one">
			<div class="container-fluid">
				<div class="col-md-9 posRel float-left mt-4">
					<div class="posRel col-sm-12 float-left">
						<?php if(count($data->image) > 1){?><h3> <?=$data->title ?></h3> <?php }?>
						<div class="pl-5 nopad-mobile read-content">
							<?php
							$content = trim($data->body);
							$fir_word = trim(array_values(array_filter(explode(' ', strip_tags($content))))[0]);
							$first = $fir_word[0];
							$second = substr($fir_word, 1);
							$replacewith = '<div class="first-tag">'.$first.'</div>'.$second.' ';
							$new_content = preg_replace("/$fir_word/", $replacewith, $content, 1);
							echo(utf8_decode($new_content));
							?>
						</div>
						<?php if(!empty($data->author)){?>
							<hr class="style-two float-left mt-5 smb-5">
							<div class="author-details">
								<div class="float-left fullWidth mb-3 col-md-2"><b>The Author <i class="fa fa-angle-double-right "></i></b></div>
								<div class="float-left fullWidth mb-3 col-md-9">
									<div class="col-sm-3 float-left">
										<div class="author-img"><img class="" src="<?=str_replace('../', $uri->site, $data->author->picture_ref)?>"></div>
									</div>
									<div class="col-sm-9 float-left">
										<a class="noDeco-h"><h5 class="mb-0"><b><?=$data->author->name?></b></h5></a>
										<p>
											<span class="fullWidth float-left"><?php
											if(!empty($data->author->bio)){
												$dd = explode('.',$data->author->bio);
												$dd = isset($dd[1]) ? $dd[0].'. '.$dd[1] : $dd[1];
												$dd = strlen($dd) > 250 ? substr($dd, 0, 250).'...' : $dd.'.';
												echo $dd;
											}
											?></span>
											<span class="fullWidth float-left"><?=$data->author->email.'  |  '.$data->author->phone?></span>
											<?php if(!empty($data->author->website)){?>
												<a target="_blank" href="<?=$data->author->website?>" class="float-left"><i class="fab fa-linkedin" style="color:#283e4a;"></i> LInkedIn Connect</a><?php }?>
											</p>
										</div>
									</div>
								</div>
							<?php }?>
						</div>
					</div>
					<div class="col-md-3 posRel float-left mt-5 hide-on-mobile" style="margin-right: 0; padding-right: 30px;">
						<div class="posRel col-sm-12 float-left">
							<div class="advert-space mt-5">
								<div class="ad-container">
									<div class="google_ad" style="float:none; margin-left:auto; margin-right:auto"><script async src="//pagead2.googlesyndication.com/pagead/js/adsbygoogle.js"></script><ins class="adsbygoogle"style="display:inline-block;width:300px;height:600px" data-ad-client="ca-pub-4696224049420135" data-ad-slot="1880693933"></ins><script>(adsbygoogle = window.adsbygoogle || []).push({});</script></div>
								</div>
							</div>
						</div>
					</div>
				</div>

				<div class="product_specs float-left pt-3 pl-5 pr-5 mb-2 bottomEl">
					<?php if(!empty($data->related) && count($data->related)){?>
						<hr class="style-two float-left mt-5 smb-5">
						<h3 class="rel fullWidth">Related Content</h3>
						<?php foreach($data->related as $item){ $body = explode('.', $item->body)[0];?>
						<div class="float-left fullWidth mb-3 col-md-6 nopad related-article">
							<div class="col-sm-3 float-left mb-4" style="margin-top: 40px;  margin-bottom: 20px;">
								<img class="" src="<?=str_replace('../', $uri->site, $item->image->src)?>" style="object-fit: cover;object-position: center;">
							</div>
							<div class="col-sm-9 float-left" style="margin-top: 40px; margin-bottom: 20px;">
								<a href='<?="{$uri->site}{$item->type}/{$item->id}-{$item->url}"?>' class="noDeco-h"><h5><b><?=$item->title?></b></h5></a>
								<p>
									<?php
									if(strlen($item->title) < 30){
										if(strlen($body < 150))echo $body.'.';else echo substr($body, 0, 150).'...';
									}else{
										echo substr($item->body,0,95).'...';
									}
									?>
								</p>
							</div>
						</div>
					<?php }
				}?>
			</div>
			<div class="page-socials">
				<ul>
					<li class="social-link"><i class="far fa-eye n_v"></i><span><?=$data->no_of_views?></span></li>
					<a data-name="fb" data-title="<?=ucwords($data->title)?>" ><li class="social-link"><i class="fab fa-facebook-f"></i></li></a>
					<a data-name="tw" data-title="<?=ucwords($data->title)?>"><li class="social-link"><i><svg class="svg" width=".8em" height=".8em" fill="none" viewBox="0 0 16 16" xmlns="http://www.w3.org/2000/svg"><path d="M9.47 6.77 15.3 0h-1.4L8.85 5.88 4.81 0H.15l6.11 8.9L.15 16h1.38l5.35-6.21L11.14 16h4.67L9.47 6.77Zm-1.9 2.2-.61-.88-4.93-7.05h2.12l3.98 5.69.62.88 5.17 7.4h-2.13L7.58 8.97Z" fill-rule="nonzero" fill-opacity="1" fill="#000" stroke="none"></path></svg></i></li></a>
					<a data-name="li" data-title="<?=ucwords($data->title)?>"><li class="social-link"><i class="fab fa-linkedin-in "></i></li></a>
					<a data-name="wh" data-title="<?=ucwords($data->title)?>"><li class="social-link"><i class="fab fa-whatsapp "></i></li></a>
				</ul>
			</div>
		</div>
		
		<?php require_once('components/footer.php')?>
		<script async src="//pagead2.googlesyndication.com/pagead/js/adsbygoogle.js"></script>
		<script>
		(adsbygoogle = window.adsbygoogle || []).push({
			google_ad_client: "ca-pub-4696224049420135",
			enable_page_level_ads: true
		});(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
			(i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
			m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
		})(window,document,'script','//www.google-analytics.com/analytics.js','ga');
		ga('create', 'UA-12843401-1', 'auto');
		ga('require', 'displayfeatures');
		ga('send', 'pageview');
		$(document).ready(function(){
			$(".page-socials").find("a").each(function () {
				$(this).socialShare();
			})
			// update views
			$('body').updateViews(function (response) {
				let res = isJson(response);
				$('.page-socials').find('li.social-link > span').text(res.views);
			});

			$('.read-content img').each(function(){
				if($(this).attr('type')=='picture'){
					var src = $(this).attr('src');
					src = src.replace('../', site.domain);
					if($(this).attr('src'))$(this).attr({'src':src});
				}
			});
			$('.ui-resizable-handle').remove();
		})
	</script>
</body>
</html>
